#!/bin/bash

# uninstall logic for InfoBackup 1-ClickBackup 6.21.2.0
# The root privilege is required to uninstall the application

###############################################################################
#             S H U T - D O W N                 S E R V I C E S               #
###############################################################################

# Shutdown Scheduler
if [ -e "/Applications/1-ClickBackup/ipc/Scheduler/running" ]; then
    echo "Shutdown Scheduler for InfoBackup 1-ClickBackup"
    touch "/Applications/1-ClickBackup/ipc/Scheduler/stop"
    echo "Wait 5 seconds before Scheduler exits"
    sleep 5
fi

# Shutdown AutoUpdateAgent
if [ -e "/Applications/1-ClickBackup/aua/bin" ]; then
    echo "Shutdown AutoUpdateAgent for InfoBackup 1-ClickBackup"
    sh "/Applications/1-ClickBackup/aua/bin/shutdown.sh"
    echo "Wait 5 seconds before AutoUpdateAgent exits"
    sleep 5
fi

###############################################################################
#        T A S K K I L L       A L L      J A V A       P R O C E S S         #
###############################################################################

# Kill all running process
sh "/Applications/1-ClickBackup/bin/taskkill" "/Applications/1-ClickBackup/BackupManager.app"
sh "/Applications/1-ClickBackup/bin/taskkill" "/Applications/1-ClickBackup/bin/BackupManager.app"
sh "/Applications/1-ClickBackup/bin/taskkill" "/Applications/1-ClickBackup/jvm/bin/java"
sh "/Applications/1-ClickBackup/bin/taskkill" "/Applications/1-ClickBackup/aua/jvm/bin/java"

###############################################################################
#                 R E M O V E                   S E R V I C E S               #
###############################################################################

# Remove Scheduler
if [ -e "/Library/StartupItems/1-ClickBackup" ]; then
    echo "Remove Scheduler for InfoBackup 1-ClickBackup from service"
    rm -rf "/Library/StartupItems/1-ClickBackup"
fi

# Remove AutoUpdateAgent
if [ -e "/Library/StartupItems/1-ClickBackup-AutoUpdate" ]; then
    echo "Remove AutoUpdateAgent for InfoBackup 1-ClickBackup from service"
    rm -rf "/Library/StartupItems/1-ClickBackup-AutoUpdate"
fi

###############################################################################
#      R E M O V E        U S E R         D E S K T O P      L I N K          #
###############################################################################

# Remove Desktop Symbolic Link
find /Users -name Desktop -type d -maxdepth 3 -mindepth 2 | while read DESKTOP_PATH;
do
    if [ -e "${DESKTOP_PATH}/1-ClickBackup" ]; then
        echo "Remove Desktop Link 1-ClickBackup from path ${DESKTOP_PATH}"
        rm -f "${DESKTOP_PATH}/1-ClickBackup"
        echo "Removed InfoBackup 1-ClickBackup Desktop Link"
    fi

    if [ -e "${DESKTOP_PATH}/1-ClickBackup" ]; then
        echo "Remove Desktop Link 1-ClickBackup from path ${DESKTOP_PATH}"
        rm -f "${DESKTOP_PATH}/1-ClickBackup"
        echo "Removed InfoBackup 1-ClickBackup Desktop Link"
    fi
done

###############################################################################
#        R E M O V E           A P P L I C A T I O N           H O M E        #
###############################################################################

# Remove InfoBackup 1-ClickBackup
cd /
if [ -e "/Applications/1-ClickBackup" ]; then
    echo "Remove InfoBackup 1-ClickBackup from Your Mac OS X"
    rm -rf "/Applications/1-ClickBackup"
fi

###############################################################################
#        R E M O V E             M A C     O S        R E C E I P T S         #
###############################################################################

# Remove Mac OS X Receipts
if [ -e "/Library/Receipts/acb.pkg" ]; then
    echo "Remove Mac OS X Receipt for acb.pkg (Path: /Library/Receipts/acb.pkg)"
    rm -rf "/Library/Receipts/acb.pkg"
fi
